RAMDirectory (Lucene 3.6.2 API)
Keywords: org.apache.lucene.store.RAMDirectory class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.store
Class RAMDirectory

    java.lang.Object
      org.apache.lucene.store.Directory
          org.apache.lucene.store.RAMDirectory

All Implemented Interfaces:
  Closeable, Serializable

    public class RAMDirectory

extends Directory
implements Serializable

A memory-resident `Directory` implementation. Locking implementation is by default the `SingleInstanceLockFactory` but can be changed with `Directory.setLockFactory(org.apache.lucene.store.LockFactory)`.

Warning: This class is not intended to work with huge indexes. Everything beyond several hundred megabytes will waste resources (GC cycles), because it uses an internal buffer size of 1024 bytes, producing millions of `byte[1024]` arrays. This class is optimized for small memory-resident indexes. It also has bad concurrency on multithreaded environments.

It is recommended to materialize large indexes on disk and use `MMapDirectory`, which is a high-performance directory implementation working directly on the file system cache of the operating system, so copying data to Java heap space is not useful.

See Also:
  Serialized Form

Field Summary
`protected Map<String,RAMFile>` | `fileMap`
`protected AtomicLong` | `sizeInBytes`

Fields inherited from class org.apache.lucene.store.Directory
`isOpen, lockFactory`

Constructor Summary
`RAMDirectory()` Constructs an empty `Directory`.
`RAMDirectory(Directory dir)` Creates a new `RAMDirectory` instance from a different `Directory` implementation.

Method Summary
`void` | `close()` Closes the store to future operations, releasing associated memory.
`IndexOutput` | `createOutput(String name)` Creates a new, empty file in the directory with the given name.
`void` | `deleteFile(String name)` Removes an existing file in the directory.
`boolean` | `fileExists(String name)` Returns true iff the named file exists in this directory.
`long` | `fileLength(String name)` Returns the length in bytes of a file in the directory.
`long` | `fileModified(String name)` Returns the time the named file was last modified.
`String[]` | `listAll()` Returns an array of strings, one for each file in the directory.
`protected RAMFile` | `newRAMFile()` Returns a new `RAMFile` for storing data.
`IndexInput` | `openInput(String name)` Returns a stream reading an existing file.
`long` | `sizeInBytes()` Return total size in bytes of all files in this directory.
`void` | `touchFile(String name)` Deprecated. Lucene never uses this API; it will be removed in 4.0.

Methods inherited from class org.apache.lucene.store.Directory
`clearLock, copy, copy, ensureOpen, getLockFactory, getLockID, makeLock, openInput, setLockFactory, sync, sync, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### fileMap

    protected final Map<String,RAMFile> fileMap

### sizeInBytes

    protected final AtomicLong sizeInBytes

Constructor Detail

### RAMDirectory

    public RAMDirectory()

  Constructs an empty `Directory`.

### RAMDirectory

    public RAMDirectory(Directory dir)
                 throws IOException

  Creates a new `RAMDirectory` instance from a different `Directory` implementation. This can be used to load a disk-based index into memory.

  Warning: This class is not intended to work with huge indexes. Everything beyond several hundred megabytes will waste resources (GC cycles), because it uses an internal buffer size of 1024 bytes, producing millions of `byte[1024]` arrays. This class is optimized for small memory-resident indexes. It also has bad concurrency on multithreaded environments.

  For disk-based indexes it is recommended to use `MMapDirectory`, which is a high-performance directory implementation working directly on the file system cache of the operating system, so copying data to Java heap space is not useful.

  Note that the resulting `RAMDirectory` instance is fully independent from the original `Directory` (it is a complete copy). Any subsequent changes to the original `Directory` will not be visible in the `RAMDirectory` instance.

  Parameters:
    `dir` - a `Directory` value
  Throws:
    `IOException` - if an error occurs

Method Detail

### listAll

    public final String[] listAll()

  Description copied from class: `Directory`
  Returns an array of strings, one for each file in the directory.

  Specified by:
    `listAll` in class `Directory`

### fileExists

    public final boolean fileExists(String name)

  Returns true iff the named file exists in this directory.

  Specified by:
    `fileExists` in class `Directory`

### fileModified

    public final long fileModified(String name)
                            throws IOException

  Returns the time the named file was last modified.

  Specified by:
    `fileModified` in class `Directory`
  Throws:
    `IOException` - if the file does not exist

### touchFile

    @Deprecated
    public void touchFile(String name)
                   throws IOException

  Deprecated. Lucene never uses this API; it will be removed in 4.0.

  Set the modified time of an existing file to now.

  Specified by:
    `touchFile` in class `Directory`
  Throws:
    `IOException` - if the file does not exist

### fileLength

    public final long fileLength(String name)
                          throws IOException

  Returns the length in bytes of a file in the directory.

  Specified by:
    `fileLength` in class `Directory`
  Parameters:
    `name` - the name of the file for which to return the length.
  Throws:
    `IOException` - if the file does not exist

### sizeInBytes

    public final long sizeInBytes()

  Return total size in bytes of all files in this directory. This is currently quantized to RAMOutputStream.BUFFER_SIZE.

### deleteFile

    public void deleteFile(String name)
                    throws IOException

  Removes an existing file in the directory.

  Specified by:
    `deleteFile` in class `Directory`
  Throws:
    `IOException` - if the file does not exist

### createOutput

    public IndexOutput createOutput(String name)
                             throws IOException

  Creates a new, empty file in the directory with the given name. Returns a stream writing this file.

  Specified by:
    `createOutput` in class `Directory`
  Throws:
    `IOException`

### newRAMFile

    protected RAMFile newRAMFile()

  Returns a new `RAMFile` for storing data. This method can be overridden to return different `RAMFile` impls, that e.g. override `RAMFile.newBuffer(int)`.

### openInput

    public IndexInput openInput(String name)
                         throws IOException

  Returns a stream reading an existing file.

  Specified by:
    `openInput` in class `Directory`
  Throws:
    `IOException`

### close

    public void close()

  Closes the store to future operations, releasing associated memory.

  Specified by:
    `close` in interface `Closeable`
  Specified by:
    `close` in class `Directory`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD